Name:           dcraw
Version:        0.0
Release:        0.fdr.0.1.20041026%{?dist_tag}
Epoch:          0
Summary:        Reads the raw image formats of more than 100 digital cameras
Group:          Applications/Multimedia
License:        Distributable
URL:            http://www.cybercom.net/~dcoffin/dcraw/
Source0:        http://www.cybercom.net/~dcoffin/dcraw/dcraw.c
#Source1:       http://www.cybercom.net/~dcoffin/dcraw/ljpeg_decode.tar.bz2
Source2:        http://www.cybercom.net/~dcoffin/dcraw/rawphoto.c
Source3:        http://www.cybercom.net/~dcoffin/dcraw/.badpixels
Source4:        http://www.cybercom.net/~dcoffin/dcraw/dcraw.1
Source5:        http://www.cybercom.net/~dcoffin/dcraw/dcwrap
Source6:        http://www.cybercom.net/~dcoffin/dcraw/parse.c
Source7:        http://www.cybercom.net/~dcoffin/dcraw/fixdates.c
Source8:        http://www.cybercom.net/~dcoffin/dcraw/decompress.c
Source9:        http://www.cybercom.net/~dcoffin/dcraw/pgm.c
Source210:      http://www.cybercom.net/~dcoffin/dcraw/sony_clear.c
Source10:       http://neuemuenze.heim1.tu-clausthal.de/~sven/crwinfo/CRWInfo-0.2.tar.gz
Source11:       http://www.cybercom.net/~dcoffin/dcraw/fujiturn.c
Source220:      http://www.cybercom.net/~dcoffin/dcraw/renum
Source230:      http://www.cybercom.net/~dcoffin/dcraw/lcfile
# Remove multiple-line string constant from crwinfo.c, gcc cannot handle it
Patch0:         crwinfo-help.patch
BuildRequires:  libjpeg-devel
Buildroot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

## Having these programs is highly recommended
# TODO -- Rex
#Requires: jhead

BuildRequires: gimp-devel
%define gimp_ver %(rpm -q --qf '%%{version}' gimp-devel | cut -d. -f-2 )
%if "%{gimp_ver}" >= "2.0"
%define gimp 1
%endif

%description
Dcraw reads and processes raw images from more than 100 digital cameras.
Raw images are the data directly read from the CCD of the camera,
without in-camera processing, without lossy JPEG compression, and in
36 or 48 bits color depth (TIFF has 24 bits). Problem of the raw
images is that they are in proprietary, camera-specific formats as
once, there seems not to be a standard format for high-color-depth
images, and second, the raw images contain headers with information
about camera settings.

This is a collection of command line tools to read and convert the raw
image files and also to get camera setting information out of them.

This program does not download the files from the camera, it only
processes the already downloaded files. Depending on your camera
model, mount your camera as a USB mass-storage device, use GPhoto2
("gtkam", "digikam", "flphoto", "gphoto2"), or a flash card reader for
downloading the files.


%package gimp
Summary:  A GIMP plug-in to load raw files of digicams (GIMP 2.0.x)
Group: 	  Applications/Multimedia
Requires: gimp >= 1:2.0.0
Requires: %{name} = %{epoch}:%{version}-%{release}
%description gimp
GIMP 2.0.x plug-in to load all raw image files of digital cameras
supported by the dcraw package. This allows direct editing of the
original images of the camera, without any conversion or compression
loss.


%prep
rm -rf $RPM_BUILD_DIR/%{name}-%{version}
mkdir $RPM_BUILD_DIR/%{name}-%{version}
cd $RPM_BUILD_DIR/%{name}-%{version}

cp -pr %{SOURCE0} .
cp -pr %{SOURCE2} .
cp -pr %{SOURCE3} .
cp -pr %{SOURCE4} .
cp -pr %{SOURCE5} .
cp -pr %{SOURCE6} .
cp -pr %{SOURCE7} .
cp -pr %{SOURCE8} .
cp -pr %{SOURCE9} .
cp -pr %{SOURCE210} .
cp -pr %{SOURCE11} .
cp -pr %{SOURCE220} .
cp -pr %{SOURCE230} .
%setup -q -T -D -a 10 -n %{name}-%{version}
pushd CRWInfo*
%patch0 -p0
popd


%build
cd $RPM_BUILD_DIR/%{name}-%{version}

gcc ${CFLAGS:-%optflags} -lm -ljpeg -o dcraw dcraw.c

# Build simple C programs
for file in *.c; do
   if [ "$file" != "dcraw.c" -a "$file" != "rawphoto.c" ]; then
      gcc ${CFLAGS:-%optflags} -lm -o ${file%.c} $file
   fi
done

# Build GIMP plug-in
%{?gimp:gimptool-2.0 --build rawphoto.c}

# Build programs provided in tarballs
pushd CRWInfo*
make %{?_smp_mflags}
popd


%install
rm -rf $RPM_BUILD_ROOT
pushd $RPM_BUILD_DIR/%{name}-%{version}

# Directories
install -d $RPM_BUILD_ROOT%{_bindir}
install -d $RPM_BUILD_ROOT%{_mandir}/man1
install -d $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

# Program files
install -m 755 dcraw $RPM_BUILD_ROOT%{_bindir}
install -m 755 decompress $RPM_BUILD_ROOT%{_bindir}
install -m 755 fixdates $RPM_BUILD_ROOT%{_bindir}
install -m 755 fujiturn $RPM_BUILD_ROOT%{_bindir}
install -m 755 parse $RPM_BUILD_ROOT%{_bindir}
install -m 755 pgm $RPM_BUILD_ROOT%{_bindir}
install -m 755 CRWInfo*/crwinfo $RPM_BUILD_ROOT%{_bindir}
install -m 755 sony_clear $RPM_BUILD_ROOT%{_bindir}
install -m 755 renum $RPM_BUILD_ROOT%{_bindir}
install -m 755 lcfile $RPM_BUILD_ROOT%{_bindir}
%{?gimp:install -D -p -m755 rawphoto $RPM_BUILD_ROOT%{_libdir}/gimp/2.0/plug-ins/rawphoto}

# Documentation
install -m 644 dcraw.1 $RPM_BUILD_ROOT%{_mandir}/man1
install -m 644 .badpixels $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/badpixels
install -m 644 CRWInfo*/README $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/README.crwinfo
install -m 644 CRWInfo*/spec $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/spec.crwinfo

popd


%clean
rm -fr $RPM_BUILD_ROOT


%files
%defattr(-,root,root)
%docdir %{_docdir}/%{name}-%{version}
%_bindir/*
%_mandir/man1/*
%_docdir/*

%if "%{?gimp:1}" == "1"
%files gimp
%defattr(-,root,root)
%{_libdir}/gimp/2.0/plug-ins/*
%endif


%changelog
* Sat Oct 30 2004 Aurelien Bompard <gauret[AT]free.fr> 0:0.0-0.fdr.0.1.20041026
- adapt to Fedora

* Tue Sep 07 2004 Christiaan Welvaart <cjw@daneel.dyndns.org> 0.20040813-2mdk
- add BuildRequires: libjpeg-devel

* Fri Aug 13 2004 Till Kamppeter <till@mandrakesoft.com> 0.20040813-1mdk
- Updated to the state of 13/08/2004 (More camera models supported).
- Removed support for GIMP 1.x as dcraw is in main and GIMP 1.x in contrib.

* Tue May 11 2004 Till Kamppeter <till@mandrakesoft.com> 0.20040511-1mdk
- Updated to the state of 11/05/2004 (Many new camera models supported).

* Thu Mar 25 2004 Thierry Vignaud <tvignaud@mandrakesoft.com> 0.20040317-2mdk
- rebuild for gimp2

* Wed Mar 17 2004 Till Kamppeter <till@mandrakesoft.com> 0.20040317-1mdk
- Updated to the state of 15/12/2003 (Many new camera models supported,
  GIMP 2.0 support, some new tools added).

* Mon Dec 15 2003 Till Kamppeter <till@mandrakesoft.com> 0.20031215-1mdk
- Updated to the state of 15/12/2003 (Many new camera models supported).

* Sun Sep 28 2003 Till Kamppeter <till@mandrakesoft.com> 0.20030928-2mdk
- Fixed patch to correct crwinfo help text.

* Sun Sep 28 2003 Till Kamppeter <till@mandrakesoft.com> 0.20030928-1mdk
- First release for Mandrake Linux
